;***************************************************************************
;* A P P L I C A T I O N   N O T E   F O R   T H E   A V R   F A M I L Y
;*
;* Number               : AVR test
;* File Name            :"T25time.asm"
;* Title                :Tiny25 timer
;* Date                 :24.12.2008
;* Version              :1.0
;* Support forum        :www.skif.biz/index.php?name=Forums&file=viewtopic&t=3078&pagenum=1
;* Support fax          :    ,   - ;-)
;* Target MCU           :tiny25
;*
;* DESCRIPTION
;*    0 AtTiny25/45/85 
;*   
;*
;* The timing is adapted for 8Mhz internal clok
;*
;*Fuses
;*  ,      -
;*    -  ,     .
;*   SPIEN   ,    
;*  -.
;*
;*  OSCCAL        = 90
;
;
;*  CKDIV         = 1   8MHZ     =0  1MHZ
;     
; 

;*  CKOUT         = 1            =0  PB3 out
;        
; (0 -    , 1 - )

;*  SUT           = 0
;     /

;*  CKSEL         = 2
;     ,  
;    /

;*  RSTDISBL      = 1
;     ,
;     
; (0 -    /, 1 -  )

;*  DWEN          = 1
; /   
; debugWire (0 - , 1 - )

;*  WDTON         = 1
;    
; (0 - , 1 -    )
;  (Watch Dog Timer)     .
;   :
;     ( WDTON  ATtiny2313),  ,
;       .
;            
;    (   WDR).
;        WDR   ,
;       .
;      .
;   ,        .
;
;*  EESAVE        = 1         < > 
; EEPROM- (0 -  , 1 - )

;*  BODLEVEL      = 7       BOR

;*  SELFPRGEN     = 1    (0 - , 1 - )
;*
;*
;*
;***************************************************************************
.device tiny25							;  ,   .
										;      ,
										;     -
										;  ,    
										;      .
										; "   -     "-
.include "tn25def.inc"					; ".include"    ,
										;      .
.def      tm	= r16                   ;  ".def"  (   )
                                        ;     ( - ).
                                        ;  R16    tm,
                                        ;          

.cseg                                   ;    CSEG (   :
                                        ; 1. CSEG -  ( );
                                        ; 2. ESEG -  EEPROM;
                                        ; 3. DSEG -  ( ,(RAM))
; ***************************************
;    25  
; ***************************************
.org 0		rjmp    reset               ;            "reset:"
.org 1		reti	;rjmp	ext_int0			; IRQ0 Handler
.org 2		reti	;rjmp	pc_int0				; PCINT0 Handler
.org 3		reti	;rjmp	tim1_compa			; Timer1 CompareA Handler
.org 4		reti	;rjmp	tim1_ovf			; Timer1 Overflow Handler
.org 5		rjmp    tim0_ovf			; Timer0 Overflow Handler
.org 6		reti	;rjmp    ee_rdy				; EEPROM Ready Handler
.org 7		reti	;rjmp	ana_comp			; Analog Comparator Handler
.org 8		reti	;rjmp	adc_conv			; ADC Conversion Handler
.org 9		reti	;rjmp	tim1_compb			; Timer1 Compare b Handler
.org 10		reti	;rjmp	tim0_compa			; Timer0 Compare a Handler
.org 11		rjmp	tim0_compb			; Timer0 Compare b Handler
.org 12		reti	;rjmp	wdt
.org 13		reti	;rjmp	usi_start
.org 14		reti	;rjmp	usi_ovf

.org 20

; ***************************************
;     
; ***************************************

reset:		ldi     r16, low(ramend)	;    - stack
			out     spl, r16            ; set low reg stack

			ldi     r16, 0x90           ;   
			out     osccal, r16         ; set generator  tm  osccal

            ldi		r16, 0x02			;     = 0b00010111 - 0x17 PB1 = 02
            out     ddrb, r16			; set port PB1 out.   ?     PB1 !

			ldi		r16, 0x02			; OCIE0B - Timer/Counter0 Compare Match B Interrupt Enable
			out     timsk, r16			;  tim0_compb  timovf 8 | 2

			ldi     r18, 0x1e			;    = 30 (   33 ;-)  ...

timer0:									;  "timer0:"    
			ldi		r16, 0x0f0			; set 30mks       tm  "0xf0" f0=240=30mks, 1  0,125
			out		ocr0a, r16			;    ocr0a  tm="0xf0"(     30mks)  
			ldi		r16, 0x28			; set 5mks,  5mks(28=40=5mks) ???   ???  .
			out		ocr0b, r16			;    ocr0b  tm="0x28"(     5mks   )

			ldi		r16, 0x063			;   - set fast PWM  wgm02 in tccr0b  08 !
			out		tccr0a, r16			; OCRb- output = 0b01100011

			ldi		r16, 0x09			; set prescaller & clock sourse  68 c.
			out		tccr0b, r16			;  

			sei							;  
			ldi		r16, 0x20			; set sleep enable = 0b00100000
			out		mcucr, r16			;   
metka:		sleep						;  
			rjmp	metka				;    ,  ... ;-)




; ******************************************
;    
; ******************************************

tim0_ovf:	dec		r18					;   , -    ?
			brne	tim0_ret			;     - 
			out     tccr0b, r18			;    ,     
			ldi     r18, 0x1e			;   = 30 (   33)
tim0_ret:	reti						;    

; ******************************************
;    
; ******************************************

tim0_compb:
			reti						;    

; ************************************************************************

; ******************************************
;  ( !)    
; ******************************************
pc_int0:								;  ,   ...
										;   -     
			reti						;    

.db "  JohnZ"					; ׸    ? ;-)

.eseg
.db "   JohnZ"					; ׸    ? ;-)

; ************************************************************************
